мир.столкновения = {
    задано: {},
};


// // // //


мир.ключники.push(function(ключ, путь, значение){
    if (!путь[0].startsWith("столкновения"))
    {
        return;
    }

    var действие = путь[1];
    var объект = путь.slice(2).join(".");
    
    if (!мир.столкновения.задано[действие])
    {
        мир.столкновения.задано[действие] = {};
    }
    мир.столкновения.задано[действие][объект] = значение;
});


// // // //


мир.столкновения.создать = function()
{
    Matter.Events.on(мир.физика.движок, "collisionActive", мир.столкновения.обработать);
};


// // // //


мир.столкновения.обработать = function(событие)
{
    var за = мир.столкновения.задано;

var вывод = "";
    for (var действие in за)
    {
        var имя1 = за[действие]["0"];
        var имя2 = за[действие]["1"];
        if (!имя1 || !имя2)
        {
            continue;
        }

        var пары = событие.pairs;
        for (var номер in пары)
        {
            var пара = пары[номер];
            var п1 = мир.объекты.имена[пара.bodyA.id];
            var п2 = мир.объекты.имена[пара.bodyB.id];
            
            if (
                !((имя1 == п1) && (имя2 == п2)) &&
                !((имя1 == п2) && (имя2 == п1))
            ) {
                continue;
            }

вывод += `${имя1} x ${имя2}, `;
console.debug("столкновение ожидаемых объектов", пара.bodyA.id, пара.bodyB.id);
        }
    }
document.getElementById("отладка").innerHTML = вывод;
};


// // // //


/*
мир.слежение.элемент = function(задано)
{
    var id = null;
    var изображение = задано["изображение"];
    if (изображение)
    {
        id = мир.изображения.элементы[изображение].id;
    }
    return document.getElementById(id);
};


// // // //


мир.слежение.обновитьЭлемент = function(элемент, тело, задано, умолчание, формула)
{
    if (!элемент || !тело)
    {
        return;
    }
    var скорость = задано.скорость ? задано.скорость : умолчание.скорость;
    var смещениеX = задано["смещение.0"] ? задано["смещение.0"] : умолчание.смещение[0];
    var смещениеY = задано["смещение.1"] ? задано["смещение.1"] : умолчание.смещение[1];

    // Сейчас.
    var x0 = 0;
    if (элемент.style.left.endsWith("px"))
    {
        x0 = элемент.style.left.slice(0, -2);
    }
    var y0 = 0;
    if (элемент.style.top.endsWith("px"))
    {
        y0 = элемент.style.top.slice(0, -2);
    }
    // Цель.
    var x1 = тело.position.x + смещениеX;
    var y1 = тело.position.y + смещениеY;
    // Более точная настройка.
    // Сейчас лишь для камеры.
    if (формула)
    {
        var итог = формула(x1, y1);
        x1 = итог[0];
        y1 = итог[1];
    }
    // Плавно.
    function lerp(v0, v1, t) {
        return v0 * (1 - t) + v1 * t;
    }
    var x = lerp(x0, x1, скорость);
    var y = lerp(y0, y1, скорость);

    элемент.style.left = `${x}px`;
    элемент.style.top = `${y}px`;
};
*/
